Name:		compat-wireless
Version:	3.4
Release:	0rc3_1%{?dist}.4
Summary:	Linux Wireless compatibility package
Group:		System Environment/Kernel
License:	GPLv2
URL:		http://wireless.kernel.org/en/users/Download
Source0:	compat-wireless-3.4-rc3-1.tar.bz2
Source1:	%{name}.files
ExclusiveArch:  i686 x86_64
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	%kernel_module_package_buildreqs

Patch1:		compat-wireless.patch
Patch2:	compat-wireless-rc-extra-patches-0000-cfg80211-fix-interface-combinations-check.patch
Patch3:	compat-wireless-rc-extra-patches-0001-mac80211-fix-truncated-packets-in-cooked-monitor-rx.patch
Patch4:	compat-wireless-rc-extra-patches-0002-mac80211-fix-logic-error-in-ibss-channel-type-check.patch
Patch5:	compat-wireless-rc-extra-patches-0003-iwlwifi-do-not-nulify-ctx-vif-on-reset.patch
Patch6:	compat-wireless-rc-extra-patches-0004-iwlwifi-fix-hardware-queue-programming.patch
Patch7:	compat-wireless-rc-extra-patches-0005-iwlwifi-use-correct-released-ucode-version.patch
Patch8:	compat-wireless-rc-extra-patches-0006-mac80211-call-ieee80211_mgd_stop-on-interface-stop.patch
Patch9:	compat-wireless-rc-extra-patches-0007-iwlwifi-use-6000G2B-for-6030-device-series.patch
Patch10:	compat-wireless-rc-extra-patches-0008-mac80211-fix-AP-mode-EAP-tx-for-VLAN-stations.patch
Patch11:	compat-wireless-rc-extra-patches-0009-iwlwifi-fix-skb-truesize-underestimation.patch
Patch12:	compat-wireless-rc-extra-patches-0010-cfg80211-warn-if-db.txt-is-empty-with-CONFIG_CFG8021.patch
Patch13:	compat-wireless-rc-extra-patches-0011-iwlwifi-update-BT-traffic-load-states-correctly.patch
Patch14:	compat-wireless-rc-extra-patches-0012-iwlwifi-do-not-use-shadow-registers-by-default.patch
Patch15:	compat-wireless-rc-extra-patches-0013-mac80211-fix-ADDBA-declined-after-suspend-with-wowla.patch
Patch16:	compat-wireless-rc-extra-patches-0014-iwlwifi-disable-WoWLAN-if-CONFIG_PM_SLEEP.patch
Patch17:	compat-wireless-rc-extra-patches-0015-iwlwifi-unregister-LEDs-if-mac80211-registration-fai.patch
Patch18:	compat-wireless-rc-extra-patches-0016-iwlwifi-don-t-mess-up-the-SCD-when-removing-a-key.patch
Patch19:	compat-wireless-rc-extra-patches-0017-iwlwifi-disable-the-buggy-chain-extension-feature-in.patch
Patch20:	compat-wireless-rc-extra-patches-0018-mac80211-fix-error-in-station-state-transitions-duri.patch
Patch21:	compat-wireless-rc-extra-patches-0019-mac80211-clean-up-remain-on-channel-on-interface-sto.patch
Patch22:	compat-wireless-rc-extra-patches-0020-mac80211-fix-non-RCU-safe-sta_list-manipulation.patch
Patch23:	compat-wireless-rc-extra-patches-0021-cfg80211-fix-interface-combinations-check.patch
Patch24:	compat-wireless-rc-extra-patches-0022-iwlwifi-fix-the-Transmit-Frame-Descriptor-rings.patch
Patch25:	compat-wireless-rc-extra-patches-0023-iwlwifi-use-correct-supported-firmware-for-6035-and-.patch
Patch26:	compat-wireless-rc-extra-patches-0024-iwlwifi-fix-TX-power-antenna-access.patch

%kernel_module_package -f %{SOURCE1} default

#debug does not work so far
#kernel_module_package -f %{SOURCE1} default debug

%description
This is a Linux wireless compatibility package which provides the latest
Linux wireless subsystem enhancements for RHEL kernels.

%prep
%setup -q -c -T -a 0

pushd compat-wireless-*
%patch1 -p1 -b compat-wireless-rc.patch
%patch2 -p1 -b compat-wireless-rc-extra-patches-0000-cfg80211-fix-interface-combinations-check.patch
%patch3 -p1 -b compat-wireless-rc-extra-patches-0001-mac80211-fix-truncated-packets-in-cooked-monitor-rx.patch
%patch4 -p1 -b compat-wireless-rc-extra-patches-0002-mac80211-fix-logic-error-in-ibss-channel-type-check.patch
%patch5 -p1 -b compat-wireless-rc-extra-patches-0003-iwlwifi-do-not-nulify-ctx-vif-on-reset.patch
%patch6 -p1 -b compat-wireless-rc-extra-patches-0004-iwlwifi-fix-hardware-queue-programming.patch
%patch7 -p1 -b compat-wireless-rc-extra-patches-0005-iwlwifi-use-correct-released-ucode-version.patch
%patch8 -p1 -b compat-wireless-rc-extra-patches-0006-mac80211-call-ieee80211_mgd_stop-on-interface-stop.patch
%patch9 -p1 -b compat-wireless-rc-extra-patches-0007-iwlwifi-use-6000G2B-for-6030-device-series.patch
%patch10 -p1 -b compat-wireless-rc-extra-patches-0008-mac80211-fix-AP-mode-EAP-tx-for-VLAN-stations.patch
%patch11 -p1 -b compat-wireless-rc-extra-patches-0009-iwlwifi-fix-skb-truesize-underestimation.patch
%patch12 -p1 -b compat-wireless-rc-extra-patches-0010-cfg80211-warn-if-db.txt-is-empty-with-CONFIG_CFG8021.patch
%patch13 -p1 -b compat-wireless-rc-extra-patches-0011-iwlwifi-update-BT-traffic-load-states-correctly.patch
%patch14 -p1 -b compat-wireless-rc-extra-patches-0012-iwlwifi-do-not-use-shadow-registers-by-default.patch
%patch15 -p1 -b compat-wireless-rc-extra-patches-0013-mac80211-fix-ADDBA-declined-after-suspend-with-wowla.patch
%patch16 -p1 -b compat-wireless-rc-extra-patches-0014-iwlwifi-disable-WoWLAN-if-CONFIG_PM_SLEEP.patch
%patch17 -p1 -b compat-wireless-rc-extra-patches-0015-iwlwifi-unregister-LEDs-if-mac80211-registration-fai.patch
%patch18 -p1 -b compat-wireless-rc-extra-patches-0016-iwlwifi-don-t-mess-up-the-SCD-when-removing-a-key.patch
%patch19 -p1 -b compat-wireless-rc-extra-patches-0017-iwlwifi-disable-the-buggy-chain-extension-feature-in.patch
%patch20 -p1 -b compat-wireless-rc-extra-patches-0018-mac80211-fix-error-in-station-state-transitions-duri.patch
%patch21 -p1 -b compat-wireless-rc-extra-patches-0019-mac80211-clean-up-remain-on-channel-on-interface-sto.patch
%patch22 -p1 -b compat-wireless-rc-extra-patches-0020-mac80211-fix-non-RCU-safe-sta_list-manipulation.patch
%patch23 -p1 -b compat-wireless-rc-extra-patches-0021-cfg80211-fix-interface-combinations-check.patch
%patch24 -p1 -b compat-wireless-rc-extra-patches-0022-iwlwifi-fix-the-Transmit-Frame-Descriptor-rings.patch
%patch25 -p1 -b compat-wireless-rc-extra-patches-0023-iwlwifi-use-correct-supported-firmware-for-6035-and-.patch
%patch26 -p1 -b compat-wireless-rc-extra-patches-0024-iwlwifi-fix-TX-power-antenna-access.patch
popd

for flavor in %flavors_to_build ; do
 cp -a compat-wireless-* _kmod_build-%{name}-${flavor}
done

%build
for flavor in %flavors_to_build; do
 pushd _kmod_build-%{name}-${flavor}
 ./scripts/driver-select redhat
 make KLIB=/lib/modules/%{kverrel} KLIB_BUILD=%{kernel_source $flavor}
 popd
done

%install
rm -rf ${RPM_BUILD_ROOT}
for flavor in %flavors_to_build; do
 pushd _kmod_build-%{name}-${flavor}

 make -C %{kernel_source $flavor} M=${PWD} INSTALL_MOD_PATH=${RPM_BUILD_ROOT} INSTALL_MOD_DIR=/extra/%{name}/ modules_install
 mkdir -p ${RPM_BUILD_ROOT}/etc/depmod.d/
 pushd ${RPM_BUILD_ROOT}/lib/modules/*/extra/%{name}/
 find . -name "*.ko" | \
   while read i ; do \
     j=`basename $i .ko`; k=`dirname $i | cut -c 3-`; echo override $j 2.6.32-* weak-updates/%{name}/$k ; \
   done > ${RPM_BUILD_ROOT}/etc/depmod.d/%{name}.conf
 popd

 install -D -m 0755 udev/compat_firmware.sh ${RPM_BUILD_ROOT}/lib/udev/compat_firmware.sh
 install -D -m 0644 udev/50-compat_firmware.rules ${RPM_BUILD_ROOT}/etc/udev/rules.d/50-compat_firmware.rules

 popd
done
chmod 0755 ${RPM_BUILD_ROOT}/lib/modules/*/extra/*
rm -f ${RPM_BUILD_ROOT}/lib/modules/*/modules.*

%clean
rm -rf ${RPM_BUILD_ROOT}

%changelog
* Thu Jun 09 2011 Stanislaw Gruszka <sgrusza [AT] redhat [DOT] com> - 0.3
- Rewrite for RHEL6 kmodtool

* Mon Jan 03 2011 Stanislaw Gruszka <sgrusza [AT] redhat [DOT] com> - 0.2
- Get rid of kmodtool to allow builds in koji
- Change name to kmod-{FEDORA_KVER}-compact-wireless-{UPSTREAM_KVER}

* Mon Dec 06 2010 Stanislaw Gruszka <sgrusza [AT] redhat [DOT] com> - 0.1
- Initial Version
